#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <fuse.h>

#include "fs.h"

static struct fuse_operations my_operations = {
  .getattr     = my_getattr,
  .readlink    = my_readlink,
#if 0
  .getdir      = NULL, /* my_getdir??? */
#else
  .getdir      = my_getdir,
#endif
  .mknod       = my_mknod,
  .mkdir       = my_mkdir,
  .unlink      = my_unlink,
  .rmdir       = my_rmdir,
  .symlink     = my_symlink,
  .rename      = my_rename,
  .link        = my_link,
  .chmod       = my_chmod,
  .chown       = my_chown,
  .truncate    = my_truncate,
#if 0
  .utime       = NULL, /* my_utime??? */
#else
  .utime       = my_utime,
#endif
  .open        = my_open,
  .read        = my_read,
  .write       = my_write,
  .statfs      = my_statfs,
  .flush       = my_flush,
  .release     = my_release,
  .fsync       = my_fsync,
#if 0
  .setxattr    = NULL, /* my_setxattr? */
  .getxattr    = NULL, /* my_getxattr? */
  .listxattr   = NULL, /* my_listxattr? */
  .removexattr = NULL, /* my_removexattr? */
#else
  .setxattr    = my_setxattr,
  .getxattr    = my_getxattr,
  .listxattr   = my_listxattr,
  .removexattr = my_removexattr,
#endif
  .opendir     = my_opendir,
  .readdir     = my_readdir,
  .releasedir  = my_releasedir,
  .fsyncdir    = my_fsyncdir,
  .init        = my_init,
  .destroy     = my_destroy,
  .access      = my_access,
  .create      = my_create,
  .ftruncate   = my_ftruncate,
  .fgetattr    = my_fgetattr,
#if 0
  .lock        = NULL, /* my_lock? */
#else
  .lock        = my_lock,
#endif
  .utimens     = my_utimens,
#if 0
  .bmap        = NULL, /* my_bmap? */
#else
  .bmap        = my_bmap,
#endif
};

int main(int argc, char *argv[])
{
  struct fs_info information;

  memset(&information, 0, sizeof(information));

  if (argc > 1) {
    information.image_filename = argv[1];
    argc--;
    argv++;
  }

  return fuse_main(argc, argv, &my_operations, &information);
}
